# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    url = "https://pbil.univ-lyon1.fr/CRAN/bin/windows/base/"


    # Getting latest version from official sources
    print("URL used is: %s" % url)
    for bs_search in bs_find_all(url, "title", proxies=proxies):
        version_name = bs_search.text.replace("Download " , "").split(" ")[0]
        version = version_name.replace('R-','')
        download_url = f"https://pbil.univ-lyon1.fr/CRAN/bin/windows/base/{version_name}-win.exe"
        latest_bin = download_url.rsplit('/')[-1]

    # Deleting outdated binaries
    remove_outdated_binaries(latest_bin)

    # Downloading latest binaries
    print("Latest %s version is: %s" % (control.name, version))
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print("Binary is present: %s" % latest_bin)

    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated

